10 EXTEND
100! UPSTATE MEDICAL CENTER - DECAL EXAMS MANAGMENT SYSTEM

   !
110! EXAMAN - MANAGER PROGRAM FOR INITIALIZATION AND EDITING

   !          OF EXAMS SPECIFICATION FILE - EXAM.FIL
120! SOURCE: EXAMAN.BAS

   ! OBJECT: EXAMAN.BAC

   !
130! WRITTEN: JULY,78 BY NAOMI HOCHBERG

   ! LAST MODIFIED: 28-DEC-78

   !	7-MAR-80	LOCATE USER FILES ON DESIGNATED DISK

   !
135!

   ! EXAM.FIL LAYOUT

   ! DIM #X%,E$(32%)=16%

   ! E$(1%)=CHR$(NO. OF EXAMS IN FILE)

   ! E$(I%)=LESSON NAME(6 CHR)+CHR$(REPEAT COUNT)+CHR$(PASSED SEGMENT)

   !        +CHR$(TOTAL SEGMENTS)+( "Y" OR " ")

   !     FOR I%=2% TO ASCII(E$(1%))+1%

   !  WHERE "Y" SPECIFIES REQUIRED EXAM,

   !  AND   " " SPECIFIED NON REQUIRED EXAM.

140!----------------------------------------------------------------

   !

   !                    - FUNCTION DEFINITIONS -

   !
190!

   ! FNF0$(G$,I%) - FUNCTION TO CHECK FOR THE EXISTENCE OF A FILE  G$

   !                 BY OPENING THE FILE FOR INPUT AS FILE NO.  I%

   !              - THE FILE NAME IS RETURNED

   !              - IF THE  FILE DOES NOT EXIST,

   !                 A SWITCH F0% IS SET WHICH LATER CAUSE CREATION

   !                 OF THE FILE

   !              - THIS FUNCTION WORKS IN CONJUNCTION WITH THE

   !                 FILE-HANDLING ERROR ROUTINE

   !
200 DEF FNF0$(G$,I%)\

    FNF0$=G$
210 IF F0% THEN 220

        ELSE OPEN G$ FOR INPUT AS FILE I%\

             CLOSE I%
220 FNEND
260!

   ! FNY0%(I$) - FUNCTION TO CHECK IF 1ST CHARACTER OF  I$  IS  Y

   !              OR  N

   !           - RETURNS  -1%  IF NEITHER

   !
270 DEF FNY0%(I$)\

    FNY0%=0%\

    I$=LEFT(I$+" ",1%)\

    IF 0%=INSTR(1%,"YN",I$) THEN PRINT "PLEASE TYPE  Y  OR  N ."\

                                 FNY0%=-1%
280 FNEND
310!

   !  FND0%(L%,L1%,L2%)- FUNCTION TO VERIFY THAT L1%<L%<=L2%

   !     IF S0 - FND0%=0%

   !        ELSE - FND0%=-1% AND A MESSAGE IS PRINTED

   !
320 DEF FND0%(L%,L1%,L2%)\

    IF L%>L1% AND L%<=L2%

    THEN FND0%=0%

    ELSE PRINT 'PLEASE TYPE AN INTEGER > ';NUM1$(L1%);\

         PRINT ' AND <=';NUM1$(L2%)\

         FND0%=-1%
330 FNEND
350!

   ! FNN0%(D1$,I%) - FUNCTION TO CHECK IF D1$ IS A LEGAL STRING 

   !                 REPRESENTATION OF AN INTEGER.

   !               - I% IS A DUMMY PARAMETER

   !               - RETURNS 0 IF D1$ IS OK.
360 DEF FNN0%(D1$,I%)\

    D1$=D1$+"0"\ I%=1%\

    I%=I%+1% UNTIL I%=LEN(D1$) OR

         0%=INSTR(1%,"1234567890 ",MID(D1$,I%,1%))\

     FNN0%=I%-LEN(D1$)*FIX(I%/LEN(D1$))\

     FNEND
500!

   ! PROGRM INITIALIZATION

   !
510 PRINT\

    PRINT TAB(7%);"UPSTATE MEDICAL CENTER - EXAM FILE MANAGER PROGRAM"\

    PRINT\ PRINT
520 GOSUB 1000\

    PRINT "ENTER COMMANDS, ONE AT A TIME."\

    PRINT
525 I$=SYS(CHR$(6%)+CHR$(-7%))

   !   ENABLE ^C TRAPING

530!

   ! MAIN CONTROL POINT - ENTERING COMMANDS

   !
540 PRINT
550 INPUT "COMMAND";I$\ I$=CVT$$(I$,136%)\

    IF I$="" THEN PRINT "PLEASE TYPE A COMMAND, OR TYPE  HELP  ."\

                  GOTO 550
560 C%=INSTR(1%,I$," ")\

    IF C% THEN I1$=LEFT(I$,C%-1%)

        ELSE I1$=I$
570 C1%=C9%\

    C1%=C1%-1% UNTIL I1$=C0$(C1%) OR C1%=0%\

    IF C1% THEN

            ON C1% GOSUB 1170,670,600,4600,4500,4000,2500,4700,4800

            ELSE PRINT "ILLEGAL COMMAND - TYPE  HELP  OR  STOP."
580 GOTO 540
590!

   ! STOP  COMMAND

   !
600 CLOSE 1%
610 GOTO 7140
660!

   !  HELP COMMAND

   !
670! &
   ! LIST ROUTINE &
   ! &
    PRINT "INIT - INITIALIZE EXAM FILE"

   \PRINT "STOP - EXIT "

   \PRINT "DELETE - DELETE FROM FILE"

   \PRINT "INSERT - INSERT BEFORE PREDEFINED EXAM"

   \PRINT "ADD - ADD TO FILE"

   \PRINT "EDIT - CHANGE SPECIFICATIONS"

   \PRINT "LIST - LIST FILE"

   \PRINT "HELP - PRINT THIS TEXT"

   \PRINT "SORT - SORT FILE IN ALPHABETIC ORDER, REQUIRED EXAMS FIRST"

   \PRINT \RETURN
990!

   ! PROGRAM INITIALIZATION SUBROUTINE

   !
1000 ON ERROR GOTO 7000

    \DIM C0$(9%)\ DIM #1%,E$(32%)=16%

    \C9%=9% \ F0%=0% \ S9%=32% \ S8%=31% \SEGNO%=50%

    \E9$="**** EXECUTION TERMINATED ****" \ U6$="DL1:"

1010 F1$=U6$+"EXAM.FIL"
1020!

    ! OPENING EVALUATION CURRENT CLERKSHIP FILE

    !
1030 OPEN FNF0$(F1$,1%)+'<40>'  AS FILE 1%
1040 IF F0% THEN GOSUB 1150 \ GOTO 1070
1060 IF STATUS AND 1024%

     THEN PRINT "THE EXAM FILE IS PROCESSED BY ANOTHER USER. WAIT."

    \CLOSE 1%\SLEEP(3%)\ GOTO 1030

1070 ON ERROR GOTO 7100
1100!

    ! INITIALIZING COMMAND ARRAY

    !
1110 C0$(1%)="INIT" \ C0$(2%)="HELP" \ C0$(3%)="STOP" \

     C0$(4%)="DELETE" \ C0$(5%)="ADD"\ C0$(6%)="EDIT"\

     C0$(7%)="LIST" \C0$(8%)="INSERT" \ C0$(9%)="SORT"
1120!

    ! INITIALIZING MAIN COMPONENTS OF FILE STRUCTURE

    !
1130 LNO%=ASCII(E$(1%))\

     RETURN
1140!

    ! SUBROUTINE TO INITIALIZE THE QUESTIONAIRE STRUCTURE FILE

    !
1150 E$(I%)="" FOR I%=2% TO S9%\

     E$(1%)=CHR$(0%)\

     LNO%=0%\

     CLOSE 1%\

     OPEN F1$ AS FILE 1%\

     RETURN
1160!

    ! SUBROUTINE FOR  INIT  COMMAND

    !
1170 INPUT 'CONFIRM';I$\

     IF FNY0%(I$) THEN 1170
1180 IF I$="N" THEN PRINT "EXAM FILE  NOT RE-INITIALIZED."\

                    RETURN
1190 GOSUB 1150
2000 PRINT "ENTER EXAM NAMES AND SPECIFICATIONS." \

     PRINT "ENTER  'STOP' AT THE END OF THE LIST." \PRINT
2020 GOSUB 3000              ! GET LESSON NAME &
    \IF ENAME$<>"STOP" THEN 2035
2030                         ! END OF LIST &
     CLOSE 1% \

     OPEN  F1$ FOR INPUT AS FILE 1% \

     RETURN
2035 IF LNO%=S8% THEN

     PRINT "EXAM TABLE IS FULL. TABLE DIMENSIONS (E$() AND S8%,S9%)"\

     PRINT "SHOULD BE INCREASED IN LINE 1000." \

     GOTO 2030
2040 GOSUB 3100              ! CHECK IF NAME NOT ALREADY IN &
     \IF LPT%<=LNO%+1%

      THEN PRINT ENAME$;" IS ALREADY IN TABLE" \ GOTO 2020
2045 GOSUB 5000

    \IF F1% THEN 2020

2050 GOSUB 3200              ! GET SPECIFICATIONS &
     \LNO%=LNO%+1%

    \E$(LNO%+1%)=ENAME$+ERPEAT$+PSEG$+TSEG$+EMUST$

    \E$(1%)=CHR$(LNO%)

    \GOTO 2020
2500! &
    ! LIST ROUTINE &
    ! &
     PRINT TAB(30%);"E X A M    F I L E"

    \PRINT \PRINT "NAME","REPEAT","PASS","TYPE"

    \PRINT ,"COUNT","CRITERIA"
2510 FOR I%=2% TO LNO%+1%

    \D$=E$(I%)

    \ENAME$=LEFT(D$,6%)

    \J%=ASCII(MID(D$,7%,1%))

    \IF J% THEN ERPEAT$=NUM1$(J%) ELSE ERPEAT$="FREE"
2515 J%=ASCII(MID(D$,8%,1%))

    \J1%=ASCII(MID(D$,9%,1%))

    \IF J%=0% AND J1%=0% THEN PSEG$=" " ELSE PSEG$=NUM1$(J%)+"/"+NUM1$(J1%)
2517 IF MID(D$,10%,1%)="" THEN EMUST$="" ELSE EMUST$=" REQ"
2520 PRINT ENAME$,ERPEAT$,PSEG$,EMUST$

    \NEXT I%

    \RETURN
3000! &
    !  GET NAME ROUTINE &
    ! &
     INPUT "NAME ";ENAME$ \ENAME$=CVT$$(ENAME$,140%)

    \IF ENAME$=""

     THEN PRINT "ENTER EXAM NAME OR 'STOP'"

     ELSE IF LEN(ENAME$)>6%

          THEN PRINT "NAME TOO LONG"

          ELSE ENAME$=ENAME$+STRING$(6%-LEN(ENAME$),32%) \RETURN
3010 GOTO 3000
3100! &
    ! CHECK IN TABLE ROUTINE &
    ! &
 FOR LPT%=2% TO LNO%+1%

\IF ENAME$=LEFT(E$(LPT%),6%) THEN RETURN
3110 NEXT LPT%

    \LPT%=LNO%+2%

    \RETURN
3200! &
    ! GET EXAM SPECIFICATION &
    ! &
     INPUT "REPEAT COUNT(CR=FREE LESSON) ";ERPEAT%

    \IF FND0%(ERPEAT%,-1%,255%) THEN 3200 ELSE ERPEAT$=CHR$(ERPEAT%)
3210 INPUT "PASS CRITERIA(CR=NO PASS CRITERIA)";D$\ D$=CVT$$(D$,140%)

    \TSEG$,PSEG$=CHR$(0%)\ GOTO 3250 IF D$=""

    \D%=INSTR(1%,D$,"/")

    \IF D%<>0% AND D%<>LEN(D$) 

     THEN 3230
3220 PRINT "PLEASE ENTER N/M ,0<=N<M<=50,(EX. 20/25)"\GOTO 3210
3230 D1$=LEFT(D$,D%-1%) \D2$=RIGHT(D$,D%+1%)

    \IF FNN0%(D1$,I%) OR FNN0%(D2$,I%) THEN 3220
3240 D1%=VAL(D1$) \ D2%=VAL(D2$)

    \IF D1%>D2% OR D2%>SEGNO% 

     THEN 3220

     ELSE PSEG$=CHR$(D1%) \ TSEG$=CHR$(D2%)
3250 INPUT "REQUIRED<Y/N>";D$

    \IF FNY0%(D$) THEN 3250

         ELSE IF D$="Y" THEN EMUST$="Y" ELSE EMUST$=""
3260 RETURN
4000! &
    ! EDIT ROUTINE &
    ! &
     GOSUB 3000       ! GET EXAM NAME &
    \IF ENAME$="STOP" THEN RETURN
4010 GOSUB 3100       ! CHECK IF IN TABLE &
    \IF LPT%>LNO%+1% THEN PRINT ENAME$;" IS NOT DEFINED YET"\GOTO 4000
4020 PRINT "ENTER NEW SPECIFICATION"\ PRINT

    \GOSUB 3200       ! GET NEW SPEC &
    \E$(LPT%)=ENAME$+ERPEAT$+PSEG$+TSEG$+EMUST$

    \RETURN
4500! &
    ! ADD ROUTINE &
    ! &
     IF LNO%=S8% THEN PRINT "TABLE IS FULL" \ RETURN
4510 GOTO 2000         ! SAME AS FOR INIT
4600! &
    ! DELETE ROUTINE &
    ! &
     GOSUB 3000        ! GET EXAM NAME &
    \ RETURN IF ENAME$="STOP"

    \GOSUB 3100        ! CHECK IF IN TABLE &
    \IF LPT%>LNO%+1% THEN PRINT ENAME$;" IS NOT DEFINED" \RETURN
4610 E$(I%)=E$(I%+1%) FOR I%=LPT% TO LNO%

    \LNO%=LNO%-1%

    \E$(1%)=CHR$(LNO%) \ RETURN
4700!

      INSERT ROUTINE

4710 IF LNO%=S8%

     THEN PRINT "TABLE IS ALREADY FULL"\GOTO 4790

4720 PRINT "   INSERT BEFORE-"\GOSUB 3000\GOTO 4790 IF ENAME$="STOP"

    \GOSUB 3100

    \IF LPT%>LNO%+1% THEN PRINT ENAME$;" IS NOT DEFINED"\GOTO 4790

4730 LPTS%=LPT%\ PRINT " ENTER NEW EXAM SPECIFICATION"\GOSUB 3000

    \GOTO 4790 IF ENAME$="STOP"

    \GOSUB 3100

    \IF LPT%<=LNO%+1% THEN PRINT ENAME$;" IS ALREADY DEFINED"\ GOTO 4790

4740 GOSUB 5000

    \IF F1% THEN 4790

     ELSE GOSUB 3200

    \ LNO%=LNO%+1%\E$(1%)=CHR$(LNO%)

    \ E$(I%+1%)=E$(I%) FOR I%=LNO% TO LPTS% STEP -1%

    \ E$(LPTS%)=ENAME$+ERPEAT$+PSEG$+TSEG$+EMUST$

4790 RETURN

4800!

      SORT ROUTINE

4805 PRINT "THE DIRECTORY WILL BE SORTED IN ALPHABETIC ORDER WITH"

    +" REQUIRED EXAMS FIRST"

4807 INPUT "SORT DIRECTORIEDS<Y/N>";I$

    \IF FNY0%(I$) THEN 4807 ELSE IF LEFT(I$,1%)="N" THEN 4840

4810 K%=LNO%

4815 K1%=0%
4820 FOR I%=2% TO K%

    \A$=MID(E$(I%),10%,1%)\B$=MID(E$(I%+1%),10%,1%)

    \IF A$<B$ OR  A$=B$ AND LEFT(E$(I%),6%)>LEFT(E$(I%+1%),6%)

     THEN A$=E$(I%)\E$(I%)=E$(I%+1%)\E$(I%+1%)=A$

    \     K1%=1%

4830 NEXT I%

    \IF K1%=1% THEN K%=K%-1%\ GOTO 4815

4840 RETURN

5000!

      VERIFY LESSON EXISTENCE

5010 ON ERROR GOTO 7115

    \F1%=0%\OPEN ENAME$+".TST" FOR INPUT AS FILE 2%

5020 CLOSE 2%

    \ON ERROR GOTO 7100

    \IF F1%=0% THEN 5040

     ELSE PRINT "***WARNING*** LESSON ";ENAME$;" IS NOT DEFINED "

      +"UNDER THIS ACCOUNT"

5030 INPUT "ENTER IT ANYWAY<Y/N>";D$

    \IF FNY0%(D$) THEN 5030 ELSE IF  LEFT(D$,1%)="Y" THEN F1%=0%

5040 RETURN

6990!

    ! ERROR-HANDLING ROUTINES

    !
7000 IF ERR<>5 THEN ON ERROR GOTO 7100\

                    RESUME 600
7020 F0%=-1%\

     RESUME
7090!

    ! ERROR ROUTINE FOR DATA-FORMAT & OTHER ERRORS

    !
7100 IF ERR=28% THEN RESUME 600

     ELSE IF ERR<>50%

      THEN PRINT "ERROR CODE #";ERR;"AT LINE ";NUM1$(ERL)

    \   PRINT E9$\RESUME 600

7110 PRINT "DATA FORMAT ERROR."\

     RESUME
7115!

    ! ERROR ROUTINE FOR OPEN LESSON FILE

    !
7116 IF ERR<>5% OR ERL<>5010 THEN GOTO 7100

     ELSE F1%=-1%\RESUME 5020

7120!

    ! GENERALIZED RETURN

    !
7130 RETURN
7140 END
